@echo off
REM Fill the following line to add the folder containing the scm command.
SET path="C:\Program Files\IBM\SDP\scmtools\eclipse";%PATH%

REM Fill the following line with the Jazz uri.
SET jazz_uri=https://localhost:9443/ccm/

REM Fill the following line with your Jazz user id.
SET jazz_id=JAZZ

REM Fill the following line with the project area name.
SET project_area="TEST"

REM Fill the following line with the Jazz stream.
SET jazz_Stream="TEST"

REM Fill the following line with the repository workspace name.
SET jazz_wsp="TEST_WKS"

REM Fill the following line with the RPP location name.
SET Location="TEST"

REM Fill the following line with the snapshot name.
SET Snapshot="xx"

REM Fill the following line with the changeset comment.
SET Comment="xx"

REM Fill the following line with the local workspace.
SET LocalLWS="C:\Migration\Test"

REM Fill the following line with the workspace drive.
REM MUST MATCH WITH THE LocalLWS DRIVE
SET DRIVE=C:

REM Fill the following line with the log file name
for /f "tokens=1,2,3 delims=:" %%a in ('time /t') do set heure=%%a
for /f "tokens=1,2,3delims=:" %%a in ('time /t') do set minute=%%b
SET TIMESTAMP=%date:~6,4%%date:~3,2%%date:~0,2%%heure%%minute%
SET LOGFILE="%LocalLWS%\.metadata\.scmtoolsentries.%TIMESTAMP%.log"

REM Fill the following line with the zOS mapping folder.
REM If there is no language definition in your 
REM context then put an folder that not exists.
SET ZCOMPFOLDER="%LocalLWS%\.metadata\zCompMap"

IF EXIST %LogFile% DEL %LogFile%
IF EXIST %LogFile%.error DEL %LogFile%.error
IF NOT EXIST "%LocalLWS%" MKDIR "%LocalLWS%"
IF NOT EXIST "%LocalLWS%\.metadata" MKDIR "%LocalLWS%\.metadata"

%DRIVE%
CD %LocalLWS%

CALL scm login -r %jazz_uri% -n Batch -u %jazz_id% -c
IF %ERRORLEVEL% NEQ 0 GOTO END
SET jazz_uri=Batch

IF "%1%"=="repair" GOTO REPAIR
IF "%1%"=="status" GOTO STATUS
IF "%1%"=="load" GOTO LOAD
IF "%1%"=="accept" GOTO ACCEPT
IF "%1%"=="showstatus" GOTO SHOWSTATUS

REM Do not create the repository workspace if .jazz5 exists
IF EXIST %LocalLWS%\.jazz5 GOTO UPLOAD
ECHO Create Workspace
CALL scm create ws -u %jazz_id% -r %jazz_uri% -s %jazz_Stream% %jazz_wsp% >> %LogFile%
IF %ERRORLEVEL% EQU 0 GOTO WSPCREATE
ECHO Creation of workspace failed: %jazz_wsp%
GOTO END

:WSPCREATE
REM MKDIR %LocalLWS%\.jazz5

:UPLOAD
time /T >> %LogFile%
SET ZCOMPOPTION=
IF EXIST %ZCOMPFOLDER% SET ZCOMPOPTION=-m %ZCOMPFOLDER%
ECHO Upload the sandbox (DO NOT STOP AND MANIPULATE THIS WINDOWS UNTIL THE END). 
ECHO For log(s) look at :
ECHO   %LogFile% for detail of standard log
ECHO   %LogFile%.error for error(s)
ECHO "scm  rpp-uploadsandbox -r %jazz_uri% -w %jazz_wsp% -l %Location% -p %project_area%  -s %jazz_Stream%  -c %Comment%  %ZCOMPOPTION%  %LocalLWS% >> %LogFile% 2>%LogFile%.error" >> %LogFile%
CALL scm  rpp-uploadsandbox -r %jazz_uri% -w %jazz_wsp% -l %Location% -p %project_area%  -s %jazz_Stream%  -c %Comment%  %ZCOMPOPTION%  %LocalLWS% >> %LogFile% 2>%LogFile%.error
IF %ERRORLEVEL% NEQ 0 ECHO Upload Sandbox failed
time /T >> %LogFile%
ECHO Creation of snapshot
ECHO Creation of snapshot >>%LogFile%
CALL scm create ss -r %jazz_uri% %jazz_Stream% -n %Snapshot% >> %LogFile% 2>>%LogFile%.error" 
IF %ERRORLEVEL% NEQ 0  ECHO Creation of snapshot failed: %Snapshot%
time /T >> %LogFile%
GOTO END

:STATUS
time /T >> %LogFile%
ECHO Cheking overall status into status.json (can be long)
ECHO Cheking overall status into status.json (can be long) >>%LogFile%
CALL scm show status --json >  status.json 2>>%LogFile%.error"
time /T >> %LogFile%
IF %ERRORLEVEL% EQU 0 GOTO SHOWSTATUS 
ECHO Cheking overall status failed
GOTO END

:SHOWSTATUS
time /T >> %LogFile%
ECHO Display overall status into status.txt
ECHO Display overall status into status.txt>>%LogFile%
CALL scm rpp-showstatus -i status.json -v >  status.txt 2>>%LogFile%.error" 
IF %ERRORLEVEL% NEQ 0  ECHO Cheking overall status failed
time /T >> %LogFile%
GOTO END

:REPAIR
time /T >> %LogFile%
ECHO Repair the repository workspace (can be very long)
ECHO Repair the repository workspace (can be very long) >>%LogFile%
CALL scm repair -r %jazz_uri%  >>%LogFile% 2>>%LogFile%.error" 
IF %ERRORLEVEL% NEQ 0  ECHO Repair the repository workspace failed
time /T >> %LogFile%
GOTO END

:LOAD
time /T >> %LogFile%
ECHO Load the repository workspace (can be long)
ECHO Load the repository workspace (can be long) >>%LogFile%
CALL scm load -r %jazz_uri% %jazz_wsp%  >>%LogFile%  2>>%LogFile%.error" 
IF %ERRORLEVEL% NEQ 0  ECHO Load the repository workspace failed
time /T >> %LogFile%
GOTO END

:ACCEPT
time /T >> %LogFile%
ECHO Accept changes in the repository workspace (can be long)
ECHO Accept changes in the repository workspace (can be long) >>%LogFile%
CALL scm accept -r %jazz_uri% --flow-components  >>%LogFile% 2>>%LogFile%.error"
IF %ERRORLEVEL% NEQ 0  ECHO Accept changes in the repository workspace failed
time /T >> %LogFile%
GOTO END

:END
CALL scm logout -r %jazz_uri%
pause